CREATE OR ALTER procedure BUILD_RENDER (
    ID_REPORT integer)
as
declare variable ID_FYSMANUAL integer;
declare variable USL_NAME varchar(200);
declare variable USL_TIME numeric(5,2);
declare variable USL_PRICE numeric(12,2);
declare variable USL_PRIC_T numeric(12,2);
declare variable USL_PRICE_FOREIGN numeric(12,2);
declare variable YET_PRICE numeric(12,2);
declare variable USL_CODE_MZ char(16);
declare variable USL_CODE char(8);
declare variable DOC_CODE char(5);
declare variable SH_SPEZ char(3);
declare variable USL_TOTALCOUNT integer;
declare variable USL_PAIDCOUNT integer;
declare variable OGRN char(15);
declare variable UR char(1);
declare variable P_CHILD integer;
declare variable SP char(3);
declare variable KOL_YET numeric(10,2);
declare variable PTR integer;
declare variable PR_T integer;
declare variable FFF integer;
declare variable YET numeric(10,2);
declare variable FFF1 numeric(12,2);
declare variable PR_USL integer;
begin
            usl_time = 0;
            usl_price_foreign = 0;
            usl_price = 0;
            yet_price = 0;
            kol_yet = 0;
  if (exists (select id_render from render where id_report = :id_report)) then
    delete from render where id_report = :id_report;

  select id_fysmanual,report.lpu_ogrn from report where id_report = :id_report
  into :id_fysmanual, :ogrn;

  select pr_tr from lpu where lpu.c_ogrn = :ogrn
  into :pr_t;

/* <? /? */
  for select usl_od.k_usl_mz, usl_od.k_ss
    from stattalon, usl_od
        where stattalon.id_report = :id_report
        and stattalon.id_stattalon = usl_od.id_stattalon
        and usl_od.k_ss<>''
    group by usl_od.k_usl_mz, usl_od.k_ss
        into :usl_code_mz, :doc_code do
  begin /* for each usl_code and doc_code */
    select ffiov.spez from ffiov where ffiov.id_report = :id_report and ffiov.shfiov = :doc_code into :sh_spez;
        /* sister's service => price = 0, single render row*/
        select fys2006.nys, fys2006.vrsy, fys2006.kod_us
            from fys2006 where fys2006.idfysmanual = :id_fysmanual and fys2006.kod_us_mz = :usl_code_mz
            into :usl_name, :usl_time, :usl_code;
         select sum(usl_od.kol) from usl_od inner join stattalon on (stattalon.id_report = :id_report and stattalon.id_stattalon = usl_od.id_stattalon)
            where usl_od.k_usl_mz = :usl_code_mz
            and usl_od.k_ss = :doc_code and
            usl_od.o_s<>'3'
            into :usl_totalcount;
        insert into render(usl_name, usl_price, usl_time, usl_ych, usl_totalcount, usl_paidcount,
                            usl_code_mz, usl_code, doc_code, sh_spez, id_report, me_ab, ok_fin, prtr, usl_price_tr)
            values(:usl_name, 0, :usl_time, 0, :usl_totalcount, 0, :usl_code_mz, :usl_code, :doc_code, :sh_spez, :id_report, 0, 0,0,0);
        when any do
        begin
            usl_price_foreign = 0;
            usl_price = 0;
            usl_time = 0;
        end
  end /* for each usl_code and doc_code */

/* <?   */
  for select usl_od.k_usl_mz, usl_od.k_vr, usl_od.urov, stattalon.was_child, usl_od.pttru, usl_od.pr_stom
    from stattalon, usl_od
        where stattalon.id_report = :id_report
        and stattalon.id_stattalon = usl_od.id_stattalon
        and usl_od.k_vr<>''
    group by usl_od.k_usl_mz, usl_od.k_vr, usl_od.urov, stattalon.was_child, usl_od.pttru, usl_od.pr_stom
        into :usl_code_mz, :doc_code, :ur, :p_child, :ptr, :pr_usl do
  begin /* for each usl_code and doc_code */
    select ffiov.spez from ffiov where ffiov.id_report = :id_report and ffiov.shfiov = :doc_code into :sh_spez;
        /* doctor's service => different prices for local and foreign, 2 render rows */
        select fys2006.nys, fys2006.kod_sp, fys2006.vrvy, fys2006.kod_us
            from fys2006 where fys2006.idfysmanual = :id_fysmanual and fys2006.kod_us_mz = :usl_code_mz
            into :usl_name, :sp, :kol_yet, usl_code;
execute procedure  calc_usl_newp_roc ( :ur, :ogrn , :p_child, :usl_code_mz, :id_fysmanual, :pr_usl) returning_values (:usl_price);
        /* for locals */
if ((((sp = '063') or (sp = '064') or (sp = '065') or (sp = '066') or (sp = '067') ) or (pr_usl=1))  and (kol_yet>0)) then
begin
fff1 = 0;
execute procedure  calc_usl_newp_roc ( :ur, :ogrn , :p_child, 'B01.065.001', :id_fysmanual,:pr_usl) returning_values (:fff1);
execute procedure  calc_usl_proc ( 'B01.065.001', :id_fysmanual, :p_child) returning_values (:yet);
usl_price = (fff1 / yet * 100.00) / 100.00;

end
        select sum(usl_od.kol) from usl_od inner join stattalon on (stattalon.id_report = :id_report and stattalon.id_stattalon = usl_od.id_stattalon)
            where usl_od.k_usl_mz = :usl_code_mz and usl_od.k_vr = :doc_code and usl_od.urov = :ur and  stattalon.was_child = :p_child and usl_od.pttru = :ptr
            and usl_od.pr_stom = :pr_usl
            into :usl_totalcount;
        select count(*) from usl_od inner join stattalon on(stattalon.id_report = :id_report and stattalon.id_stattalon = usl_od.id_stattalon and usl_od.paid = 1)
            where usl_od.k_usl_mz = :usl_code_mz and usl_od.k_vr = :doc_code and usl_od.urov = :ur
            and  stattalon.was_child = :p_child and usl_od.o_s<>'3' and usl_od.pttru = :ptr and usl_od.pr_stom = :pr_usl
            into :usl_paidcount;
        select sum(usl_od.yet) from usl_od inner join stattalon on(stattalon.id_report = :id_report and stattalon.id_stattalon = usl_od.id_stattalon )
            where usl_od.k_usl_mz = :usl_code_mz and usl_od.k_vr = :doc_code and usl_od.urov = :ur
            and  stattalon.was_child = :p_child and usl_od.o_s<>'3'  and usl_od.me_ab=0
            and (usl_od.paid = 1 or usl_od.paid = 2) and usl_od.pttru = :ptr and usl_od.pr_stom = :pr_usl
            into :yet_price;
      if (yet_price is null) then
       yet_price = 0;
        if (usl_totalcount > 0) then
        begin
         if ((pr_t=1) and (ptr=1)) then
         begin
          fff = trunc(:usl_price*1.07*100.00);
          usl_pric_t =  fff /100.00;
          fff = 0;
            insert into render(usl_name, usl_price, usl_time, usl_ych, usl_totalcount, usl_paidcount, usl_code_mz,
             usl_code, doc_code, sh_spez, id_report, me_ab, ok_fin, yet, prtr, usl_price_tr, pr_stom )
                values(:usl_name, :usl_pric_t, :usl_time, :usl_price_foreign, :usl_totalcount, :usl_paidcount, :usl_code_mz, :usl_code, :doc_code, :sh_spez, :id_report,
                 0, 0, :yet_price, :ptr, :usl_price, :pr_usl);
         end
              else
            insert into render(usl_name, usl_price, usl_time, usl_ych, usl_totalcount, usl_paidcount, usl_code_mz,
             usl_code, doc_code, sh_spez, id_report, me_ab, ok_fin, yet, prtr, usl_price_tr, pr_stom)
                values(:usl_name, :usl_price, :usl_time, :usl_price_foreign, :usl_totalcount, :usl_paidcount, :usl_code_mz, :usl_code, :doc_code, :sh_spez, :id_report,
                 0, 0, :yet_price, :ptr, 0, :pr_usl);

        end
        when any do
        begin
            usl_time = 0;
            usl_price_foreign = 0;
            usl_price = 0;
            yet_price = 0;
        end
  end /* for each usl_code and doc_code */
end
